# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import playerlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')
block  = es.import_addon('sam/base/pcontrol')

# * VARIABLES
invisibilitytag     = '#greenINVISIBILITY'
invisibility_hudtag = 'INVISIBILITY'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### CREATE PLAYERS VAR ###
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_invisibility_%s' % ply.steamid)
		var.set(0)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### CREATE PLAYERS VAR ###
	for ply in playerlib.getPlayerList('#all'):
		if int(es.ServerVar('sam_invisibility_%s' % ply.steamid)) == 1: removefrom(ply)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid, target, menu=0):
	if int(es.ServerVar('sam_invisibility_%s' % target.steamid)) != 1:
		giveto(target)
		func.tell('#all', func.lang_pcontrol('invisibility_giveto_target', {'target':target.name}), invisibilitytag)
	else:
		removefrom(target)
		func.tell('#all', func.lang_pcontrol('invisibility_removefrom_target', {'target':target.name}), invisibilitytag)
	if menu == 0: block.function(userid, 'Invisibility', None)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def giveto(target):
	targetvar = es.ServerVar('sam_invisibility_%s' % target.steamid)
	targetvar.set(1)
	target.setColor(255, 255, 255, 0)
	if target.getPrimary(): target.setWeaponColor(255, 255, 255, 0)
	elif target.getSecondary(): target.setWeaponColor(255, 255, 255, 0)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def removefrom(target):
	targetvar = es.ServerVar('sam_invisibility_%s' % target.steamid)
	targetvar.set(0)
	target.setColor(255, 255, 255, 255)
	if target.getPrimary(): target.setWeaponColor(255, 255, 255, 255)
	elif target.getSecondary(): target.setWeaponColor(255, 255, 255, 255)

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def player_activate(ev):
	var = es.ServerVar('sam_invisibility_%s' % ev['userid'])
	var.set(0)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def player_spawn(ev):
	targetvar = es.ServerVar('sam_invisibility_%s' % ev['userid'])
	if int(targetvar) == 1: removefrom(playerlib.getPlayer(ev['userid']))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def round_end(ev):
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_invisibility_%s' % ply.steamid)
		var.set(0)

# ============================================================================================================================================================= #