# MAIN IMPORTS ================================================================================================================================================= #
import psyco
psyco.full()
import es
import playerlib
import usermsg
import gamethread
import cmdlib
import random
# ============================================================================================================================================================== #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')
block  = es.import_addon('sam/base/pcontrol')

# * VARIABLES
crazydrugtag     = '#greenCRAZY DRUG'
crazydrug_hudtag = 'CRAZY DRUG'

# ============================================================================================================================================================== #
# ========================================================================= UNLOAD ============================================================================= #
# ============================================================================================================================================================== #
def load():
	### Create Vars ###
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_crazydrug_%s' % ply.steamid)
		var.set(0)

	### CMDs ###
	cmdlib.registerSayCommand('!crazydrug', crazydrugCMD,'SAM')
	cmdlib.registerSayCommand('!sam_crazydrug', crazydrugCMD,'SAM')

# ============================================================================================================================================================== #
# ========================================================================= UNLOAD ============================================================================= #
# ============================================================================================================================================================== #
def unload():
	### Uncrazydrug Players ###
	for ply in playerlib.getPlayerList('#all'):
		if int(es.ServerVar('sam_crazydrug_%s' % ply.steamid)) == 1: undrug(ply)

	### Unreg ###
	cmdlib.unregisterSayCommand('!crazydrug')
	cmdlib.unregisterSayCommand('!sam_crazydrug')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def crazydrugCMD(userid, args):
	admin = playerlib.getPlayer(userid)
	if admins.isAdmin(admin.steamid):
		if admins.checkAccess(admin.steamid, 'Crazy Drug'):
			if args:
				try: moduleAction(userid, playerlib.getPlayer(es.getuserid(args[0])), 1)
				except: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), crazydrug_hudtag)
			else: block.function(userid, 'Crazy Drug', None)

# ============================================================================================================================================================== #
# ======================================================================= MAIN BLOCKS ========================================================================== #
# ============================================================================================================================================================== #
def moduleAction(userid, target, menu=0):
	if int(es.ServerVar('sam_crazydrug_%s' % target.steamid)) != 1:
		drug(target)
		func.tell('#all', func.lang_pcontrol('crazydrug_target_druged', {'target':target.name}), crazydrugtag)
	else:
		undrug(target)
		func.tell('#all', func.lang_pcontrol('crazydrug_target_undruged', {'target':target.name}), crazydrugtag)
	if menu == 0: block.function(userid, 'Crazy Drug', None)

# ============================================================================================================================================================== #
# ======================================================================== FUNCTIONS =========================================================================== #
# ============================================================================================================================================================== #
def drug(target):
	targetvar = es.ServerVar('sam_crazydrug_%s' % target.steamid)
	targetvar.set(1)
	usermsg.shake(target, 50, 0.1)
	usermsg.fade(target, 2, 1, 100, random.randint(0, 255), random.randint(0, 255), random.randint(0, 255), random.randint(100, 125)) # target, 2, 1, 100, 0, 0, 0
	gamethread.delayedname(.01, 'sam_crazydrug_%s' % target, drug, (target))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def undrug(target):
	targetvar = es.ServerVar('sam_crazydrug_%s' % target.steamid)
	targetvar.set(0)
	gamethread.cancelDelayed('sam_crazydrug_%s' % target)

# ============================================================================================================================================================== #
# ========================================================================= EVENTS ============================================================================= #
# ============================================================================================================================================================== #
def player_activate(ev):
	var = es.ServerVar('sam_crazydrug_%s' % ev['userid'])
	var.set(0)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def round_end(ev):
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_godmode_%s' % ply.steamid)
		var.set(0)
		undrug(ply)

# ============================================================================================================================================================== #